# cache2k version 0.23 release notes

## New and Noteworthy

  * ClockProPlus eviction becomes default, after a year of testing in production
  * Single JAR cache2k-all for runtime 
  * OSGi support

## Possible breakages

  * none

## Fixes and Improvements

  * Fix classloader issue affecting some Android phones, [Github Issue 33](https://github.com/cache2k/cache2k/issues/33)
  * In general do not use the ThreadContextClassLoader (TCCL) default for the ServiceLoader, needed for the OSGi bundle
  * buildNumber and version available via JMX
  * Restore thread interrupt status, in case a InterruptedException is caught during processing of an entry

## Using this cache2k version, Java SE/EE environments

````
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-api</artifactId>
      <version>0.23</version>
      <scope>compile</scope>
    </dependency>
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-all</artifactId>
      <version>0.23</version>
      <scope>runtime</scope>
    </dependency>
````



## Using this cache2k version, Android

````
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-api</artifactId>
      <version>0.23</version>
    </dependency>
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-core</artifactId>
      <version>0.23</version>
      <scope>runtime</scope>
    </dependency>
````